package com.sun.xml.parser;

import java.util.Vector;

final class AttributeListImpl implements AttributeListEx {
   private Vector names = new Vector();
   private Vector types = new Vector();
   private Vector values = new Vector();
   private Vector specified = new Vector();
   private Vector defaults = new Vector();
   private String idAttributeName;

   public void addAttribute(String var1, String var2, String var3, String var4, boolean var5) {
      this.names.addElement(var1);
      this.types.addElement(var2);
      this.values.addElement(var3);
      this.defaults.addElement(var4);
      this.specified.addElement(var5 ? Boolean.TRUE : null);
   }

   public void clear() {
      this.names.removeAllElements();
      this.types.removeAllElements();
      this.values.removeAllElements();
      this.specified.removeAllElements();
      this.defaults.removeAllElements();
   }

   public String getDefault(int var1) {
      try {
         return var1 < 0 ? null : (String)this.defaults.elementAt(var1);
      } catch (IndexOutOfBoundsException var2) {
         return null;
      }
   }

   public String getIdAttributeName() {
      return this.idAttributeName;
   }

   public int getLength() {
      return this.names.size();
   }

   public String getName(int var1) {
      try {
         return var1 < 0 ? null : (String)this.names.elementAt(var1);
      } catch (IndexOutOfBoundsException var2) {
         return null;
      }
   }

   public String getType(int var1) {
      try {
         return var1 < 0 ? null : (String)this.types.elementAt(var1);
      } catch (IndexOutOfBoundsException var2) {
         return null;
      }
   }

   public String getType(String var1) {
      return this.getType(this.names.indexOf(var1));
   }

   public String getValue(int var1) {
      try {
         return var1 < 0 ? null : (String)this.values.elementAt(var1);
      } catch (IndexOutOfBoundsException var2) {
         return null;
      }
   }

   public String getValue(String var1) {
      return this.getValue(this.names.indexOf(var1));
   }

   public boolean isSpecified(int var1) {
      Object var2 = this.specified.elementAt(var1);
      return var2 == Boolean.TRUE;
   }

   void setIdAttributeName(String var1) {
      this.idAttributeName = var1;
   }
}
