package com.sun.xml.parser;

import com.sun.xml.tree.XmlDocument;
import com.sun.xml.tree.XmlDocumentBuilder;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class DocumentBuilderImpl extends DocumentBuilder {
   private DocumentBuilderFactory dbf;
   // $FF: renamed from: er org.xml.sax.EntityResolver
   private EntityResolver field_0 = null;
   // $FF: renamed from: eh org.xml.sax.ErrorHandler
   private ErrorHandler field_1 = null;
   private Parser parser = null;
   private XmlDocumentBuilder builder = null;
   private boolean namespaceAware = false;
   private boolean validating = false;

   DocumentBuilderImpl(DocumentBuilderFactory var1) {
      this.dbf = var1;
      this.builder = new XmlDocumentBuilder();
      if (var1.isValidating()) {
         this.parser = new ValidatingParser();
         this.validating = true;
      } else {
         this.parser = new Parser();
      }

      if (var1.isNamespaceAware()) {
         this.builder.setDisableNamespaces(false);
         this.namespaceAware = true;
      }

      this.builder.setParser(this.parser);
      this.parser.setDocumentHandler(this.builder);
   }

   public boolean isNamespaceAware() {
      return this.namespaceAware;
   }

   public boolean isValidating() {
      return this.validating;
   }

   public Document newDocument() {
      return new XmlDocument();
   }

   public Document parse(InputSource var1) throws SAXException, IOException {
      if (var1 == null) {
         throw new IllegalArgumentException("InputSource cannot be null");
      } else {
         if (this.field_0 != null) {
            this.parser.setEntityResolver(this.field_0);
         } else {
            this.parser.setEntityResolver(new Resolver());
         }

         if (this.field_1 != null) {
            this.parser.setErrorHandler(this.field_1);
         }

         this.parser.parse(var1);
         return this.builder.getDocument();
      }
   }

   public void setEntityResolver(EntityResolver var1) {
      this.field_0 = var1;
   }

   public void setErrorHandler(ErrorHandler var1) {
      this.field_1 = var1;
   }
}
